      FUNCTION EGVRTL(XMIN,IRR)
C---
C Get energy of virtual photons in real photon approximation.
C* EGVRTL : scaled energy of the virtual photon by the beam energy.
C* XMIN   : minimum scaled energy.
C* IRR    : seed for random number generator.
C*
      IMPLICIT REAL*8(A-H,O-Z)
      REAL*4 RAN
      EGVRTL= 0.D0
      NLOOP = 0
      IF(XMIN.GE.1.D0) THEN
       PRINT *,'!!! Warning in EGVRTL!!! XMIN>1.  --- XMIN=',XMIN
       RETURN
      ENDIF
1     CONTINUE
      NLOOP = NLOOP + 1
      IF(NLOOP.GT.10000) THEN
         PRINT *,' NLOOP > 10000 in EGVRTL !!!'
         EGVRTL= X
         RETURN
      ENDIF
      X     = XMIN/( 1.D0 - RAN(IRR)*(1.D0-XMIN) )
      XR    = DLOG(X)/DLOG(XMIN)
      IF( RAN(IRR).GT.XR ) GO TO 1
      EGVRTL= X
C---
      IF(EGVRTL.LT.XMIN) THEN
       PRINT *,'!!! in EGVRTL !!!, ENG<XMIN, EGVRTL,XMIN=',EGVRTL,XMIN
       EGVRTL = 1.0001D0*XMIN
      ENDIF
C---
      RETURN
      END
