C   05/06/87 812161326  MEMBER NAME  FOURIE   *.FORT     M  FORTRAN77   0000
      SUBROUTINE FOURIE(CPHI,CRHO,CKER,N,MDIM)                          0000
C SOLVE 2-DIM POISSON EQUATION BY FOURIER TRANSFORMATION.               0000
C    LAPLACIAN PHI = - 2*PI*RHO                                         0000
C   SUBR.KERNEL MUST BE CALLED IN ADVANCE TO GET CKER.                  0000
C INPUT: CRHO(I,J) (1<=I<=N,1<=J<=N)   CHARGE IN THE RECTANGULAR        0000
C               (DX,DY) CENTERED AT (I,J), I.E., RHO*DX*DY.             0000
C               COMPLEX*16. REAL AND IMAGINARY PARTS ARE                0000
C               FOURIER TRANSFORMED SIMULTANEOUSLY.                     0000
C        N      POWER OF 2.                                             0000
C OUTPUT:CPHI(I,J) (1<=I<=N,1<=J<=N)   POTENTIAL AT (I,J).              0000
C               NOTE THAT PHI HAS THE DIMENSION OF CHARGE.              0000
C               COMPLEX*16, CORRESPONDING TO THE REAL AND IMAGINARY     0000
C               PARTS OF CRHO.                                          0000
C                                                                       0000
      IMPLICIT REAL*8 (A,B,D-H,O-Z)                                     0000
      IMPLICIT COMPLEX*16 (C)                                           0000
      PARAMETER (PI=3.141592653589793D0)                                0000
      DIMENSION CPHI(MDIM,*),CRHO(MDIM,*)                               0000
      DIMENSION CKER(MDIM,*)                                            0000
                                                                        0000
      CALL CFTR2(CRHO,N,MDIM,.TRUE.)                                    0000
      DO 10 J=1,N                                                       0000
        DO 20 I=1,N                                                     0000
          CPHI(I,J)=CRHO(I,J)*CKER(I,J)                                 0000
20      CONTINUE                                                        0000
10    CONTINUE                                                          0000
      CALL CFTR2(CPHI,N,MDIM,.FALSE.)                                   0000
      RETURN                                                            0000
      END                                                               0000
