      SUBROUTINE INIT1(KKK,KFLD,IRG,IRTN,ZZMM,NP,XY,XY0,ZZ,ENG,
     %      SIG,GCUT,EMIT,ALPHA,SLOPE,OFFSET,LSPIN,ISPIN,SPIN
     *,     SLANT )
C----- SET INITIAL CONDITIONS -----
C  CREATE INITIAL CONDITIONS OF MACRO PARTICLES WITH 3-DIM GAUSSIAN
C  DISTRIBUTION. IF OTHER DISTRIBUTION IS DESIRED, THIS SUBROUTINE
C  MUST BE REWRITTEN. IT MUST DEFINE THE FOLLOWING VARIABLES.
C  XY(N,J,L) (N=1,NP, J=1,2, L=1,2)
C     X (FOR J=1) AND Y(J=2) OF N-TH MACRO PARTICLE IN L-TH BEAM
C     IN UNITS OF METER. THESE ARE DEFINED BY EXTRAPOLATING TO THE
C     COLLISION POINT S=0.
C  XY0(N,J,L)
C     X'=DX/DT AND Y'=DY/DT. THE TIME T IS MEASURED IN UNITS OF METER
C     BY MULTIPLYING THE VELOCITY OF LIGHT.
C  ZZ(N,L)
C     LONGITUDINAL COORDINATE OF N-TH MACRO PARTICLE IN L-TH BEAM
C     IN UNITS OF METER. THE ORIGIN IS THE CENTER OF EITHER BEAM
C     AND POSITIVE AT THE HEAD OF EITHER BEAM.
C  ENG(N,L)
C     INITIAL ENERGY OF N-TH MACRO PARTICLE IN L-TH BEAM IN UNITS
C     OF THE REFERENCE ENERGY ENGY(L). DOUBLE PRECISION.
C     FOR THE MOMENT, DEFINE ENG=1 FOR ALL THE PARTICLES BECAUSE
C     GRAPHIC ROUTINES ARE NOT READY TO TREAT ENG>1.
C  MEANING OF THESE VARIABLES WILL CHANGE AFTER CALLING SUBR.INIT2 BUT
C  WILL BE RESTORED AFTER TRACKING EXCEPT THE PARTICLE ID (N),
C  WHICH IS CHANGED IN SUBROUTINE INIT2.
C
C  THIS ROUTINE IS CALLED TWICE: FIRST KKK=0 AND THEN KKK=1.
C  IN THE FIRST CALL, ARRAYS MUST  N O T  BE FILLED. MINIMUM AND
C  MAXIMUM OF Z FOR L-TH BEAM MUST BE STORED IN ZZMM(1,L) AND
C  ZZMM(2,L) RESPECTIVELY. THIS IS TO COMPUTE THE REQUIRED NUMBER
C  OF TIME STEPS.
C  IN THE SECOND CALL, ALL THE ARRAYS MUST BE FILLED. ZZMM IS
C  IGNORED.
      REAL*4 XY(NP,2,2),XY0(NP,2,2),ZZ(NP,2),SPIN(NP,3,*),XYZ(2)
      REAL*8 ENG(NP,2)
      REAL*4 SIG(3,2),GCUT(3,2),
     %       EMIT(2,2),ALPHA(2,2),SLOPE(2,2),OFFSET(2,2),
     %       ZZMM(2,2),SIGCOR(3)
     *,      SLANT(2)
      INTEGER LSPIN(2)
      REAL*4 PI/3.14159 26535 89793E0/
C
      IRTN=0
      IRG00=IRG
      DO 400 L=1,2
      DO 220 J=1,3
      IF(KFLD.EQ.4.AND.J.EQ.1) GOTO 220
      IF(GCUT(J,L).GE.0) THEN
          SIGCOR(J)=SIG(J,L)
        ELSE
          COR=1
          DO 210 I=1,3
  210     COR=1.0-GCUT(J,L)*COR/SQRT(2.0*PI)*EXP(0.5*(GCUT(J,L)*COR)**2)
          SIGCOR(J)=COR*SIG(L,J)
        ENDIF
  220 CONTINUE
      ZZMM(1,L)=+1D30
      ZZMM(2,L)=-1D30
      DO 300 IXY=1,2
      IF(KFLD.EQ.4.AND.IXY.EQ.1) GOTO 300
      BTINV=EMIT(IXY,L)/SIG(IXY,L)**2
      GCUT1=ABS(GCUT(IXY,L))
CC    OFFST1=OFFSET(IXY,L)*SIG(IXY,L)
      DO 280 N=1,NP
      N1=0
  240 N1=N1+1
      IF(N1.GT.20) GOTO 900
      CALL GAUSSN(IRG,XYZ,1)
      IF(ABS(XYZ(1)).GE.GCUT1) GOTO 240
      XY1=SIGCOR(IXY)*XYZ(1)
      N1=0
  260 N1=N1+1
      IF(N1.GT.20) GOTO 900
      CALL GAUSSN(IRG,XYZ,1)
      IF(ABS(XYZ(1)).GE.GCUT1) GOTO 260
      IF(KKK.EQ.0) GOTO 280
      XYP=BTINV*(SIGCOR(IXY)*XYZ(1)-ALPHA(IXY,L)*XY1)
      XY(N,IXY,L)=XY1
      XY0(N,IXY,L)=XYP
CC    XY(N,IXY,L)=XY1+OFFST1
CC    XY0(N,IXY,L)=XYP+SLOPE(IXY,L)
  280 CONTINUE
  300 CONTINUE
C---
      IF(KKK.NE.0) THEN
      CS = COS( SLANT(L) )
      SN = SIN( SLANT(L) )
      OFFST1=OFFSET(1,L)*SIG(1,L)
      OFFST2=OFFSET(2,L)*SIG(2,L)
      DO 281 N=1,NP
      X0 = XY(N,1,L)
      Y0 = XY(N,2,L)
      XP0= XY0(N,1,L)
      YP0= XY0(N,2,L)
      XY(N,1,L) = X0*CS - Y0*SN  + OFFST1
      XY(N,2,L) = X0*SN + Y0*CS  + OFFST2
      XY0(N,1,L) = XP0*CS - YP0*SN + SLOPE(1,L)
      XY0(N,2,L) = XP0*SN + YP0*CS + SLOPE(2,L)
281   CONTINUE
      ENDIF
C---
      IF(KFLD.EQ.4.AND.KKK.NE.0) THEN
          CALL CLEAR(XY(1,1,L),NP)
          CALL CLEAR(XY0(1,1,L),NP)
        ENDIF
      GCUT1=ABS(GCUT(3,L))
      DO 360 N=1,NP
      N1=0
  320 N1=N1+1
      IF(N1.GT.20) GOTO 900
      CALL GAUSSN(IRG,XYZ,1)
      IF(ABS(XYZ(1)).GE.GCUT1) GOTO 320
      ZZ1=SIGCOR(3)*XYZ(1)
      IF(KKK.EQ.0) THEN
          ZZMM(1,L)=MIN(ZZMM(1,L),ZZ1)
          ZZMM(2,L)=MAX(ZZMM(2,L),ZZ1)
        ELSE
          ZZ(N,L)=ZZ1
          ENG(N,L)=1D0
        ENDIF
  360 CONTINUE
  400 CONTINUE
      IF(KKK.EQ.0) IRG=IRG00
      IF(KKK.EQ.0) RETURN
      IF(ISPIN.EQ.0) RETURN
      DO 440 L=1,2
      LS=LSPIN(L)
      IF(LS.EQ.0) GOTO 440
      SZ=3-2*L
C        INITIAL SPIN IS HELECITY +1 FOR EITHER BEAM.
      DO 420 N=1,NP
      SPIN(N,1,LS)=0.0
      SPIN(N,2,LS)=0.0
      SPIN(N,3,LS)=SZ
  420 CONTINUE
  440 CONTINUE
      RETURN
  900 WRITE(6,910) (GCUT(J,L),J=1,3)
  910 FORMAT(' (SUBR.INIT1) GCUT=',1P3E10.3,' TOO SMALL. FAR FROM ',
     %  'GAUSSIAN. THIS STEP IGNORED.')
      IRTN=1
      RETURN
      END
