C   24/06/87 802091910  MEMBER NAME  POISFL   *.FORT        FORTRAN77   0000
      SUBROUTINE POISFL(NX,NY,DX,DY,Q,QX,EX,EY)                         0000
C  SOLVE 2-DIM POISSON EQUATION USING FLAT BEAM APPROXIMATION.          0000
C   - LAPLACIAN PHI(X,Y)= 2*PI*RHO(X,Y)                                 0000
C     EX(I)=DPHI/DX     AT X=(I+1/2)*DX   0<=I<=NX                      0000
C     EY(I,J)=DPHI/DY   AT X=I*DX, Y=(J+1/2)*DY    1<=I<=NX, 0<=J<=NY.  0000
C                                                                       0000
      REAL*8 Q(NX,NY,2),QX(NX,2)                                        0000
      REAL*4 EX(0:NX,2),EY(NX,0:NY,2)                                   0000
      REAL*8 EX1,EY1,CI                                                 0000
      DATA PI/3.14159 26535 8979E0/                                     0000
C                                                                       0000
      FAC=PI*DY/DX                                                      0000
      DO 300 L=1,2                                                      0000
      DO 230 I=1,NX                                                     0000
      EY(I,0,L)=0                                                       0000
      EY1=0                                                             0000
      DO 210 J=1,NY                                                     0000
      EY1=EY1+Q(I,J,L)                                                  0000
  210 EY(I,J,L)=EY1                                                     0000
      QX(I,L)=EY1                                                       0000
      DO 220 J=0,NY                                                     0000
  220 EY(I,J,L)=FAC*(QX(I,L)-2D0*EY(I,J,L))                             0000
  230 CONTINUE                                                          0000
      DO 250 I=0,NX                                                     0000
      EX1=0                                                             0000
      CI=I+0.5D0                                                        0000
      DO 240 K=1,NX                                                     0000
  240 EX1=EX1+QX(K,L)/(K-CI)                                            0000
  250 EX(I,L)=EX1                                                       0000
  300 CONTINUE                                                          0000
      RETURN                                                            0000
      END                                                               0000
