C   05/06/87 709041544  MEMBER NAME  POISNF   *.FORT        FORTRAN77   0000
      SUBROUTINE POISNF(NF,Q,PHI,QF,PHIF,FKER)                          0000
C  SOLVE 2-DIM POISSON EQUATION                                         0000
C   - LAPLACIAN PHI(X,Y)= 2*PI*RHO(X,Y)                                 0000
C  BY FOURIER TRANSFORMATION. MORE SPECIFICALLY,                        0000
C   (2*PHI(I,J)-PHI(I+1,J)-PHI(I-1,J))/DX**2                            0000
C   +(2*PHI(I,J)-PHI(I,J+1)-PHI(I,J-1))/DY**2                           0000
C   = 2*PI*Q(I,J)/(DX*DY)                                               0000
C        (NX=NY=NF/2= POWER OF 2)                                       0000
C  SUBR.KERNEL MUST BE CALLED IN ADVANCE TO PREPARE FKER.               0000
C                                                                       0000
C  CPU TIME FOR ONE CALL ON HITAC S810  (AUG.1987)                      0000
C    NX=NF/2     16      32      64     128     256                     0000
C    T(MSEC)     3.1     8.0    23.1                                    0000
C                        8.6    25.5                (2 SEPT REVISED)    0000
C      (POISSN REQUIRES 12 MSEC FOR NX=16)                              0000
      IMPLICIT REAL*8 (A-H,O-Z)                                         0000
      REAL*8 Q(NF/2,NF/2,2),PHI(NF/2,NF/2,2)                            0000
      REAL*8 QF(2,NF+1,NF+1),PHIF(2,NF+1,NF+1),FKER(2,NF+1,NF+1)        0000
      NF1=NF+1                                                          0000
      NFH=NF/2                                                          0000
      DO 200 J=1,NF1                                                    0000
      DO 200 I=1,NF1                                                    0000
      QF(1,I,J)=0D0                                                     0000
  200 QF(2,I,J)=0D0                                                     0000
      DO 220 J=1,NFH                                                    0000
      DO 220 I=1,NFH                                                    0000
      QF(1,I,J)=Q(I,J,1)                                                0000
  220 QF(2,I,J)=Q(I,J,2)                                                0000
      CALL FOURIE(PHIF,QF,FKER,NF,NF1)                                  0000
      DO 240 J=1,NFH                                                    0000
      DO 240 I=1,NFH                                                    0000
      PHI(I,J,1)=PHIF(1,I,J)                                            0000
  240 PHI(I,J,2)=PHIF(2,I,J)                                            0000
      RETURN                                                            0000
      END                                                               0000
