C   14/04/87 706021359  MEMBER NAME  RLINS3   *.FORT     M  FORTRAN77   0000
C******************** RLINS3 ********************                       0000
      SUBROUTINE RLINS3( A,N1,N,AN,NANS,WORK,IRTN,EPS )                 0000
C  THIS IS A REVISED VERSION OF MSL-SUBROUTINE-DLINS2.                  0000
C  INCLUDED IS THE SCALING PROCEDURE MENSIONED IN MSL-MANUAL I(PP2-3)   0000
      IMPLICIT REAL*4 ( A-H,O-Z )                                       0000
      DIMENSION A(N1,N),AN(N),NANS(N),WORK(N)                           0000
      CHARACTER*8 IRC                                                   0000
      DATA ZERO/0.0D0/ , ONE/1.0D0/ , CONST/0.01D0/                     0000
C------ ARGUMENTS CHECK ------                                          0000
      IF ( N    ) 600,600,100                                           0000
  100 IF ( N-N1 ) 110,110,600                                           0000
  110 IF ( EPS  ) 120,130,130                                           0000
  120 EPS = 1.0D-6                                                      0000
  130 CONTINUE                                                          0000
      IRTN = 0                                                          0000
      NM    = N-1                                                       0000
      EPSS  = EPS*CONST                                                 0000
C------ SCALING OF A & AN ------                                        0000
      DO 30 I=1,N                                                       0000
      S=ZERO                                                            0000
      DO 10 J=1,N                                                       0000
   10 S=S+ABS(A(I,J))                                                   0000
      IF(S.EQ.ZERO) GO TO 900                                           0000
      S=ONE/S                                                           0000
      DO 20 J=1,N                                                       0000
   20 A(I,J)=S*A(I,J)                                                   0000
   30 AN(I)=S*AN(I)                                                     0000
      DO 60 J=1,N                                                       0000
      S=ZERO                                                            0000
      DO 40 I=1,N                                                       0000
   40 S=S+ABS(A(I,J))                                                   0000
      IF(S.EQ.ZERO) GO TO 910                                           0000
      S=ONE/S                                                           0000
      DO 50 I=1,N                                                       0000
   50 A(I,J)=S*A(I,J)                                                   0000
   60 WORK(J)=S                                                         0000
      FACN=ZERO                                                         0000
      DO 70 I=1,N                                                       0000
   70 FACN=FACN+ABS(AN(I))                                              0000
      IF(FACN.EQ.ZERO) RETURN                                           0000
      DO 80 I=1,N                                                       0000
   80 AN(I)=AN(I)/FACN                                                  0000
C------ SEARCH FOR LARGEST ELEMENT ------                               0000
      DO 350 K=1,N                                                      0000
         AMAX = ZERO                                                    0000
         DO 200 I=K,N                                                   0000
            AX = A(I,K)                                                 0000
            IF( ABS(AMAX) .GE. ABS(AX) ) GO TO 200                      0000
            IROW = I                                                    0000
            AMAX = AX                                                   0000
  200 CONTINUE                                                          0000
         IF( ABS(AMAX) .LE. EPS ) GO TO 500                             0000
         IF( K .EQ. N ) GO TO 350                                       0000
C------ GAUSS    ELIMINATION STARTS ------                              0000
         NANS(K) = IROW                                                 0000
         IF( NANS( K  ) .EQ. K ) GO TO 300                              0000
         A(IROW,K) = A(K,K)                                             0000
         A(K,K)    = AMAX                                               0000
  300    CONTINUE                                                       0000
         PIVOT = -ONE/AMAX                                              0000
         K1 = K+1                                                       0000
         DO 320 J=K1,N                                                  0000
            T = A(IROW,J)*PIVOT                                         0000
            A(IROW,J) = A(K,J)                                          0000
            A(K,J) = -T                                                 0000
            DO 310 I=K1,N                                               0000
               A(I,J) = A(I,J)+T*A(I,K)                                 0000
  310       CONTINUE                                                    0000
  320    CONTINUE                                                       0000
C                                                                       0000
         T = AN(IROW)*PIVOT                                             0000
         AN(IROW) = AN(K)                                               0000
         AN(K) = -T                                                     0000
         IF( ABS(T)-EPSS ) 350,350,330                                  0000
  330    CONTINUE                                                       0000
         DO 340 I=K1,N                                                  0000
            AN(I) = AN(I)+T*A(I,K)                                      0000
  340    CONTINUE                                                       0000
  350 CONTINUE                                                          0000
      NANS(N) = N                                                       0000
C------ BACKWARD TRANSFORMATION ------                                  0000
      AN(N) = AN(N)/A(N,N)                                              0000
      IF( N .EQ. 1 ) GO TO 999                                          0000
      DO 410 J=1,NM                                                     0000
         JJ = N-J+1                                                     0000
         JJJ = JJ-1                                                     0000
         T = -AN(JJ)                                                    0000
         DO 400 I=1,JJJ                                                 0000
            AN(I) = AN(I)+T*A(I,JJ)                                     0000
  400    CONTINUE                                                       0000
  410 CONTINUE                                                          0000
      GO TO 999                                                         0000
  500 CONTINUE                                                          0000
      IRTN = 100                                                        0000
      WRITE(6,1001) AMAX , EPS , K                                      0000
      GO TO 999                                                         0000
  600 CONTINUE                                                          0000
      IRTN = 1000                                                       0000
      WRITE(6,1002) N , N1                                              0001
      GO TO 1000                                                        0001
C------ RE-ADJUST SCALE OF SOLUTION ------                              0001
  999 DO 700 I=1,N                                                      0001
  700 AN(I)=FACN*WORK(I)*AN(I)                                          0001
 1000 RETURN                                                            0001
C------ FORMAT STATEMENT ------                                         0001
 1001 FORMAT(1H0,'(SUBR. DLINS3) MATRIX IS NEARLY SINGULAR.' / 15X,     0001
     1'THE PIVOT ',D25.16,' IS LESS THAN OR EQUAL TO EPS ',D25.16,'.',  0001
     2 / 15X,'(',I4,'-TH ELIMINATING PROCESS)')                         0001
 1002 FORMAT(1H0,'(SUBR. DLINS3) N=',I4,', N1=',I4,', N MUST BE POSITIVE0001
     1 AND LESS THAN OR EQUAL TO N1.'/15X,'RETURN WITH NO CALCULATION.')0001
  900 IRC='ROW '                                                        0001
      II=I                                                              0001
      GO TO 920                                                         0001
  910 IRC='COLUMN'                                                      0001
      II=J                                                              0001
  920 IRTN=100                                                          0001
      WRITE(6,930) II,IRC                                               0001
  930 FORMAT(' (SUBR.DLINS3) ALL THE ELEMENTS IN THE ',I3,'-TH ',       0001
     %       A7,'ARE ZERO.')                                            0001
      RETURN                                                            0001
      END                                                               0001
