C   26/08/88 909281413  MEMBER NAME  TDMULT   *.FORT     M  FORTRAN77   0000
C******************** TDMULT ****************************************** 0000
      SUBROUTINE TDMULT(MP,NF,NFL,NP,XX,FF,LMOD,SCAL,TTLT,TTL)          0000
C  MULTI-PLOT IN A PAGE BY TOPDRAWER                                    0000
C    (ABEL VERSION. IFLTD,KPL,NPLX,NPLY ARE IN COMMON BLOCK.)           0000
C  KPL-TH PLOT AMONG NPLX*NPLY PLOTS IN A PAGE.                         0000
C  AT THE FIRST CALL, DEFINE KPL=0.  THEN TDMULT ADDS 1 TO KPL AT       0000
C  EACH CALL.  NPLX AND NPLY MUST NOT BE CHANGED SINCE THE FIRST        0000
C  CALL.                                                                0000
C  OUTPUT FOR TOPDRAWER ON FILT IFLTD.                                  0000
C                                                                       0000
C  MP:     FIRST DIMENSION OF XX AND FF.                                0000
C  NF:     NUMBER OF CURVES TO BE PLOTTED IN THE PRESENT PLOT.          0000
C  NFL:    NUMBER OF CURVES FOR WHICH LEFT-HAND SCALE IS TO BE USED.    0000
C          (1=<NFL<=NF)   NFL (AND NF-NFL) CURVES SHARE THE SAME SCALE. 0000
C  NP(J) (J=1,NF):  NUMBER OF POINTS ON J-TH CURVE.  (NP(J)<=MP)        0000
C  XX(I,J),FF(I,J)   (I=1,NP(J)),(J=1,NF)  :  POINTS TO BE PLOTTED.     0000
C  LMOD(J) (J=1,NF):  INTEGER ARRAY. LINE MODE FOR J-TH CURVE.          0000
C          IF <=0 PLOT POINTS.                                          0000
C           0:DOT   -1>=LMOD>=-10  TOPDRAWER SYMBOL nP (n=ABS(LMOD)-1)  0000
C          IF >0, JOIN BY LINE.                                         0000
C           1:SOLID,   2:DOTS, 3:DASHES, 4:DAASHES,                     0000
C           5:DOTDASH, 6:PATTERNED, 7:FUNNY                             0000
C  SCAL(K,N):  3*3 REAL*4 ARRAY.  DEFINES THE SCALE AND LIMITS OF       0000
C          THE X (N=1), LEFT-Y (N=2) AND RIGHT-Y (N=3) AXES.            0000
C          SCAL(1,N)   =0.0 LINEAR AXIS,  ><0.0 LOG AXIS.               0000
C          SCAL(2,N)   LOWER LIMIT                                      0000
C          SCAL(3,N)   UPPER LIMIT       SCAL(3,N) CAN BE < SCAL(2,N)   0000
C            FOR SCAL(2,N) AND SCAL(3,N),  >=1E30 AND <=-1E30 CAN       0000
C            BE SPECIFIED FOR THE MAXIMUM AND MINIMUM OF THE DATA.      0000
C            IN THIS CASE, ACTUALLY USED LIMITS ARE STORED ON RETURN.   0000
C          IF NFL=NF, SCAL FOR N=3 IS NOT NEEDED.                       0000
C  TTLT    TITLE STRING FOR ALL THE NPLX*NPLY PLOTS. USED WHEN          0000
C          KPL=0 ONLY.                                                  0000
C          TWO-LINE TITLE IS POSSIBLE BY SEPARATING THEM BY ;.          0000
C          3RD LINE IS POSSIBLE BUT IS WRITTEN AT THE BOTTOM WITH       0000
C          TINY CHARACTERS (UP TO 124 CHARACTERS).                      0000
C  TTL     TITLE STRING ON TOP, BOTTOM, LEFT AND RIGHT FOR THE PRESENT  0000
C          PLOT. SEPARATE FOUR STRINGS BY DELIMITER ;.                  0000
C          IT IS RECOMMENDED TO PLACE ';' AT THE END OF THE WHOLE       0000
C          STRING OF TTLT AND TTL.                                      0000
C                                                                       0000
      INCLUDE '@TDCOM'
      REAL*4 XX(MP,NF),FF(MP,NF),SCAL(3,3)                              0000
      INTEGER NP(NF),LMOD(NF),LS(0:4)                                   0000
      CHARACTER*(*) TTL,TTLT                                            0000
C      CHARACTER*160 TEXT                                                0000
      CHARACTER*10 LMODE(7)/'SOLID','DOTS','DASHES','DAASHES',          0000
     %       'DOTDASH','PATTERNED','FUNNY'/                             0000
C                                                                       0000
C  ARGUMENT CHECK                                                       0000
      IF(NPLX.LE.0.OR.NPLY.LE.0) GOTO 900                               0000
      IF(KPL.LT.0.OR.KPL.GE.NPLX*NPLY) GOTO 920                         0000
      IF(NFL.LE.0.OR.NFL.GT.NF) GOTO 940                                0000
      IF(NF.LE.0) GOTO 1000                                             0000
      DO 200 J=1,NF                                                     0000
  200 IF(MP.LT.NP(J).OR.NP(J).LE.0) GOTO 960                            0000
C                                                                       0000
C  FIND LIMIT                                                           0000
      DO 260 N=1,3                                                      0000
      IF(NFL.EQ.NF.AND.N.EQ.3) GOTO 260                                 0000
      IF(SCAL(2,N).GT.-1E30.AND.SCAL(2,N).LT.1E30.AND.                  0000
     %   SCAL(3,N).GT.-1E30.AND.SCAL(3,N).LT.1E30) GOTO 260             0000
      IF(SCAL(2,N).LT.-1E30.AND.SCAL(3,N).LT.-1E30) SCAL(3,N)=1E31      0000
      IF(SCAL(2,N).GT.1E30.AND.SCAL(3,N).GT.1E30) SCAL(2,N)=-1E31       0000
      J1=1                                                              0000
      J2=NF                                                             0000
      IF(N.EQ.2) J2=NFL                                                 0000
      IF(N.EQ.3) J1=NFL+1                                               0000
      IF(N.EQ.1) THEN                                                   0000
          FMIN=XX(1,J1)                                                 0000
          FMAX=XX(1,J1)                                                 0000
          DO 220 J=J1,J2                                                0000
          DO 220 I=1,NP(J)                                              0000
          FMIN=MIN(FMIN,XX(I,J))                                        0000
  220     FMAX=MAX(FMAX,XX(I,J))                                        0000
        ELSE                                                            0000
          FMIN=FF(1,J1)                                                 0000
          FMAX=FF(1,J1)                                                 0000
          DO 230 J=J1,J2                                                0000
          DO 230 I=1,NP(J)                                              0000
          FMIN=MIN(FMIN,FF(I,J))                                        0000
  230     FMAX=MAX(FMAX,FF(I,J))                                        0000
        ENDIF                                                           0000
      IF(SCAL(1,N).NE.0) THEN                                           0000
          IF(FMAX.LE.0) GOTO 980                                        0000
          IF(FMIN.LE.0) FMIN=FMAX*1E-4                                  0000
        ENDIF                                                           0000
      DO 240 I=2,3                                                      0000
      IF(SCAL(I,N).LT.-1E30) SCAL(I,N)=FMIN                             0000
  240 IF(SCAL(I,N).GT.1E30) SCAL(I,N)=FMAX                              0000
      IF(SCAL(2,N).EQ.SCAL(3,N)) THEN                                   0000
          IF(SCAL(1,N).NE.0) SCAL(2,N)=SCAL(2,N)-1.0                    0000
          SCAL(3,N)=SCAL(3,N)+1.0                                       0000
        ENDIF                                                           0000
  260 CONTINUE                                                          0000
C                                                                       0000
      XWL0=0                                                            0000
      XWH0=13                                                           0000
      YWL0=0                                                            0000
      YWH0=10                                                           0000
      CHUNIT=0.1                                                        0000
C       RATIO OF CHARACTER SIZE 1 TO TEXT COORDINATE INCREMENT 1        0001
      CHSZ1=NINT(6+14/SQRT(FLOAT(NPLX*NPLY)))/10.0                      0001
      CHSZ2=NINT(10*CHSZ1/1.2)/10.0                                     0001
      CHSZ3=CHSZ1/20.0                                                  0001
      CHSZ0=CHSZ1*1.2                                                   0001
      TMARGN=4*CHSZ0*CHUNIT                                             0001
      BMARGN=2.0*CHUNIT                                                 0001
      XWL=XWL0                                                          0001
      XWH=XWH0                                                          0001
      YWL=YWL0+BMARGN                                                   0001
      YWH=YWH0-TMARGN                                                   0001
      DXWW=(XWH-XWL)/NPLX                                               0001
      DYWW=(YWH-YWL)/NPLY                                               0001
      WMRGNT=0.15                                                       0001
      WMRGNB=0.15                                                       0001
      WMRGNL=0.15                                                       0001
      WMRGNR=0.15                                                       0001
      DXW=(1-WMRGNL-WMRGNR)*DXWW                                        0001
      DYW=(1-WMRGNT-WMRGNB)*DYWW                                        0001
      IPLX=MOD(KPL,NPLX)                                                0001
      IPLY=NPLY-1-MOD(KPL/NPLX,NPLY)                                    0001
      X000=XWL+IPLX*DXWW                                                0001
      X00=X000+WMRGNL*DXWW                                              0001
      Y000=YWL+IPLY*DYWW                                                0001
      Y00=Y000+WMRGNB*DYWW                                              0001
      IF(KPL.NE.0) GOTO 380                                             0001
      CALL TDHEAD                                                       0001
      CALL SUBPOS(TTLT,3,NS,LS)                                         0001
      IF(NS.LE.0) GOTO 360                                              0001
      NC1=LS(1)-LS(0)-1                                                 0001
      IF(NS.EQ.1) THEN                                                  0001
          IF(NC1.LE.0) GOTO 320                                         0001
          CHSZ=MIN(CHSZ0,(XWH-XWL)*0.96/NC1/CHUNIT)                     0001
          X1=(XWL+XWH)/2-0.5*(NC1-1)*CHSZ*CHUNIT+0.02*(XWH-XWL)         0001
          Y1=(YWH+YWH0)/2                                               0001
          WRITE(IFLTD,310) X1,Y1,CHSZ,TTLT(LS(0)+1:LS(1)-1)             0001
  310     FORMAT(' TITLE ',2F7.3,' SIZE ',F4.2,/,                       0001
     %         ' MORE ',1H',1X,A,1H')                                   0001
        ELSE                                                            0001
          NC2=LS(2)-LS(1)-1                                             0001
          NC12=MAX(NC1,NC2)                                             0001
          IF(NC12.LE.0) GOTO 320                                        0001
          CHSZ=MIN(CHSZ0,(XWH-XWL)*0.96/NC12/CHUNIT)                    0001
          X1=(XWL+XWH)/2-0.5*(NC1-1)*CHSZ*CHUNIT+0.02*(XWH-XWL)         0001
          X2=(XWL+XWH)/2-0.5*(NC2-1)*CHSZ*CHUNIT+0.02*(XWH-XWL)         0001
          Y1=(YWH+2*YWH0)/3                                             0001
          Y2=(2*YWH+YWH0)/3                                             0001
          WRITE(IFLTD,310) X1,Y1,CHSZ,TTLT(LS(0)+1:LS(1)-1),            0001
     %                 X2,Y2,CHSZ,TTLT(LS(1)+1:LS(2)-1)                 0001
        ENDIF                                                           0001
  320 IF(NS.LE.2) GOTO 360                                              0001
      NC3=LS(3)-LS(2)-1                                                 0001
      IF(NC3.LE.0) GOTO 360                                             0001
      CHSZ=1.0                                                          0001
      MAXNC=62                                                          0001
      NC4=0                                                             0001
      IF(NC3.GT.MAXNC) THEN                                             0001
          NC4=MIN(MAXNC,NC3-MAXNC)                                      0001
          NC3=MAXNC                                                     0001
        ENDIF                                                           0001
      X1=XWL+0.02*(XWH-XWL)                                             0001
      Y1=(YWL+YWL0)/2                                                   0001
      WRITE(IFLTD,330) X1,Y1,CHSZ,TTLT(LS(2)+1:LS(2)+NC3)               0001
  330 FORMAT(' TITLE ',2F7.3,' SIZE ',F4.2,/,                           0001
     %     ' MORE ',1H',1X,A,1H')                                       0001
      IF(NC4.GE.1) WRITE(IFLTD,340) TTLT(LS(2)+NC3+1:LS(2)+NC3+NC4)     0001
  340 FORMAT(' MORE ',1H',A,1H')                                        0001
  360 WRITE(IFLTD,410) (XWL0+XWH0)/2,(YWL0+YWH0)/2,                     0001
     %                  XWH0-XWL0,YWH0-YWL0                             0001
C                                                                       0001
  380 WRITE(IFLTD,390) X00,X00+DXW,Y00,Y00+DYW,SCAL(2,1),SCAL(3,1),     0001
     %  CHSZ3,CHSZ2                                                     0001
  390 FORMAT(' SET WINDOW X FROM ',                                     0001
     %     F6.3,' TO ',F6.3,' Y FROM ',F6.3,' TO ',F6.3,/,              0001
     % ' SET LIMIT X FROM ',1PE11.4,' TO ',1PE11.4,/,                   0001
     % ' SET TICKS SIZE ',0PF6.3,'; SET LABELS SIZE ',0PF5.2)           0001
      IF(SCAL(1,1).NE.0) WRITE(IFLTD,400)                               0001
  400 FORMAT(' SET SCALE X LOG')                                        0001
        WRITE(IFLTD,410) X000+DXWW/2,Y000+DYWW/2,DXWW,DYWW              0001
  410   FORMAT(' BOX ',2F8.3,' SIZE ',2F8.3)                            0001
C                                                                       0001
C TITLE                                                                 0001
      CALL SUBPOS(TTL,4,NS,LS)                                          0001
      IF(NS.LE.0) GOTO 480                                              0001
      NC=LS(1)-LS(0)-1                                                  0001
      IF(NC.LE.0) GOTO 430                                              0001
      CHSZ=MIN(CHSZ1,DXW/NC/CHUNIT)                                     0001
      WRITE(IFLTD,420) CHSZ,TTL(LS(0)+1:LS(1)-1)                        0001
  420 FORMAT(' TITLE TOP SIZE ',F4.2,1X,1H',A,1H')                      0001
  430 IF(NS.LE.1) GOTO 480                                              0001
      NC=LS(2)-LS(1)-1                                                  0001
      IF(NC.LE.0) GOTO 450                                              0001
      CHSZ=MIN(CHSZ2,DXW/NC/CHUNIT)                                     0001
      WRITE(IFLTD,440) CHSZ,TTL(LS(1)+1:LS(2)-1)                        0001
  440 FORMAT(' TITLE BOTTOM SIZE ',F4.2,1X,1H',A,1H')                   0001
  450 IF(NS.LE.2) GOTO 480                                              0001
      NC=LS(3)-LS(2)-1                                                  0001
      IF(NC.LE.0) GOTO 470                                              0001
      CHSZ=MIN(CHSZ2,DYW/NC/CHUNIT)                                     0001
      X1=X000+0.05*DXWW                                                 0002
      Y1=Y00+0.5*DYW-0.5*(NC-1)*CHSZ*CHUNIT                             0002
      WRITE(IFLTD,460) X1,Y1,CHSZ,TTL(LS(2)+1:LS(3)-1)                  0002
  460 FORMAT(' TITLE ',2F7.3,' SIZE ',F4.2,' ANGLE 90 ',                0002
     %             1H',A,1H')                                           0002
  470 IF(NS.LE.3) GOTO 480                                              0002
      NC=LS(4)-LS(3)-1                                                  0002
      IF(NC.LE.0) GOTO 480                                              0002
      CHSZ=MIN(CHSZ2,DYW/NC/CHUNIT)                                     0002
      X1=X000+DXWW-0.05*DXWW                                            0002
      Y1=Y00+0.5*DYW-0.5*(NC-1)*CHSZ*CHUNIT                             0002
      WRITE(IFLTD,460) X1,Y1,CHSZ,TTL(LS(3)+1:LS(4)-1)                  0002
C                                                                       0002
  480 DO 800 J=1,NF                                                     0002
      ILR=1                                                             0002
      IF(J.GT.NFL) ILR=2                                                0002
      IF(J.NE.1.AND.J.NE.NFL+1) GOTO 600                                0002
      WRITE(IFLTD,500) SCAL(2,ILR+1),SCAL(3,ILR+1)                      0002
  500 FORMAT(' SET LIMIT Y FROM ',1PD11.4,' TO ',1PD11.4)               0002
      IF(SCAL(1,ILR+1).NE.0) WRITE(IFLTD,520)                           0002
  520 FORMAT(' SET SCALE Y LOG')                                        0002
      IF(NFL.EQ.NF) WRITE(IFLTD,540)                                    0002
  540 FORMAT(' SET AXIS ALL ON',/,' SET TICKS ALL ON',/,                0002
     %       ' SET LABELS LEFT ON  RIGHT OFF BOTTOM ON  TOP OFF')       0002
      IF(NFL.NE.NF.AND.ILR.EQ.1) WRITE(IFLTD,560)                       0002
  560 FORMAT(' SET AXIS   LEFT ON  RIGHT OFF BOTTOM ON  TOP ON ',/,     0002
     %       ' SET TICKS  LEFT ON  RIGHT OFF BOTTOM ON  TOP ON ',/,     0002
     %       ' SET LABELS LEFT ON  RIGHT OFF BOTTOM ON  TOP OFF')       0002
      IF(NFL.NE.NF.AND.ILR.EQ.2) WRITE(IFLTD,580)                       0002
  580 FORMAT(' SET AXIS   LEFT OFF RIGHT ON  BOTTOM OFF TOP OFF',/,     0002
     %       ' SET TICKS  LEFT OFF RIGHT ON  BOTTOM OFF TOP OFF',/,     0002
     %       ' SET LABELS LEFT OFF RIGHT ON  BOTTOM OFF TOP OFF')       0002
  600 LM=LMOD(J)                                                        0002
      IF(LM.GE.8) LM=1                                                  0002
      IF(LM.LE.-11) LM=-1                                               0002
      IF(LM.LT.0) WRITE(IFLTD,610) -LM-1,CHSZ                           0002
  610 FORMAT(' SET SYMBOL ',I1,'P  SIZE ',F4.2)                         0002
      IF(LM.GE.0) WRITE(IFLTD,620) CHSZ                                 0002
  620 FORMAT(' SET SYMBOL SIZE ',F4.2)                                  0002
      WRITE(IFLTD,630) (XX(I,J),FF(I,J),I=1,NP(J))                      0002
  630 FORMAT(3(1PD11.4,',',1PD11.4,';'))                                0002
      IF(LM.GE.1) THEN                                                  0002
          WRITE(IFLTD,660) LMODE(LM)                                    0002
  660     FORMAT(' JOIN 1 ',A)                                          0002
        ELSE                                                            0002
          WRITE(IFLTD,680)                                              0002
  680     FORMAT(' PLOT')                                               0002
        ENDIF                                                           0002
  800 CONTINUE                                                          0002
      GOTO 1000                                                         0002
C                                                                       0002
  900 WRITE(6,910)                                                      0002
  910 FORMAT(' (SUBR.TDMULT) INVALID ARGUMENT NPLX AND/OR NPLY.')       0002
      GOTO 1000                                                         0002
  920 WRITE(6,930)                                                      0002
  930 FORMAT(' (SUBR.TDMULT) INVALID ARGUMENT KPL.')                    0002
      GOTO 1000                                                         0002
  940 WRITE(6,950)                                                      0002
  950 FORMAT(' (SUBR.TDMULT) INVALID ARGUMENT NF OR NFL.')              0002
      GOTO 1000                                                         0002
  960 WRITE(6,970)                                                      0002
  970 FORMAT(' (SUBR.TDMULT) INVALID ARGUMENT MP OR NP.')               0002
      GOTO 1000                                                         0002
  980 WRITE(6,990)                                                      0002
  990 FORMAT(' (SUBR.TDMULT) FUNCTION ALL NON-POSITIVE FOR LOG SCALE',  0002
     %    ' PLOT.')                                                     0002
      GOTO 1000                                                         0002
 1000 KPL=MOD(KPL+1,NPLX*NPLY)                                          0002
      RETURN                                                            0002
      END                                                               0002
