C   15/12/87 005011142  MEMBER NAME  VARLST   *.FORT        FORTRAN77   0000
      SUBROUTINE VARLST(E0,SIG,DSRP,CGSLM0,CGSLUM,                      0000
     %  NP,XY,XYP,ZZ,ENG,RP,                                            0000
     %  MAXPH,THIN,NPH,IPHEL,XYPH,EPH,RPPH,                             0000
     %  LSHIST,NSBIN,SBIN2,SBIN,SBMIN,SBMAX,EBMIN,EBMAX,                0000
     %  LCMPTN,CPLUM,CPB2,CPBN,CSBMIN,CSBMAX,CBMIN,CBMAX,               0000
     %         GGLUM,GGB2,GGBN,GSBMIN,GSBMAX,                           0000
     %  NLEP,MAXLEP,THINLE,ELEMIN,ELEMAX,LEOR,EELE,XYLE)                0000
C                                                                       0000
C  THIS ROUTINE PROVIDES A WAY TO ACCESS THE VARIABLES                  0000
C  WITHOUT INVOKING KNOWLEDGE OF POINTERS SO THAT USERS CAN WRITE       0000
C  FORTRAN TO PRINT/PLOT WHAT THEY NEED.                                0000
C  IT IS CALLED AT THE END OF EACH STEP.                                0000
C                                                                       0000
C-----                                                                  0000
C E0(L) REFERENCE BEAM ENERGY OF L-TH BEAM IN GEV.                      0000
C (SIG(K,L),K=1,3,L=1,2)  INITIAL BEAM SIZE SIGX,SIGY AND SIGZ          0000
C       OF L-TH BEAM. (METER)                                           0000
C ((DSRP(L,IXY),L=1,2),IXY=1,2)                                         0000
C       HORIZONTAL AND VERTICAL DISRUPTION PARAMETER FOR L-TH BEAM.     0000
C CGSLM0  UNPERTURBED LUMINOSITY (1/CM**2/SEC)                          0000
C CGSLUM  LUMINOSITY (1/CM**2/SEC)                                      0000
C-----                                                                  0000
C NP    NUMBER OF MACRO PARTICLES IN EACH BEAM.                         0000
C (((XY(N,K,L),N=1,NP),K=1,2),L=1,2)                                    0000
C       X(K=1) AND Y(K=2) OF THE INTERCEPT ON S=0 PLANE OF N-TH         0000
C       MACRO PARTICLE IN L-TH BEAM.  (METER)                           0000
C (((XYP(N,K,L),N=1,NP),K=1,2),L=1,2)                                   0000
C       FINAL DX/DS(K=1) AND DY/DS(K=2). (RADIAN)                       0000
C ((ENG(N,L),N=1,NP),L=1,2)  REAL*8.                                    0000
C       FINAL ENERGY OF N-TH MACRO PARTICLE IN L-TH BEAM.               0000
C       UNIT E0(L).                                                     0000
C ((ZZ(N,L),N=1,NP),L=1,2)                                              0000
C       Z COORDINATE OF N-TH MACRO PARTICLE IN L-TH BEAM. (METER)       0000
C       ORIGIN:CENTER OF EACH BUNCH. POSITIVE AT THE HEAD.              0000
C       THIS DOES NOT CHANGE BY COLLISION.                              0000
C ((RP(N,L),N=1,NP),L=1,2)                                              0000
C       RADIAL ANGLE  SQRT((DX/DS)**2+(DY/DS)**2) IN RADIAN.            0000
C-----                                                                  0000
C MAXPH   MAXIMUM NUMBER OF PHOTON STORAGE PER BEAM.                    0000
C (NPH(L),L=1,2)  NUMBER OF STORED PHOTON FROM L-TH BEAM.               0000
C THIN  THINNING FACTOR OF PHOTON STORAGE. EXPECTED NUMBER OF PHOTONS   0000
C       IS  NPH(L)/THIN.                                                0000
C ((IPHEL(N,L),N=1,NPH(L)),L=1,2)                                       0000
C       MACRO PARTICLE ID IN L-TH BEAM WHICH EMITTED N-TH PHOTON.       0000
C       1<=IPHEL<=NP.                                                   0000
C (((XYPH(N,K,L),N=1,NPH(L)),K=1,4),L=1,2)                              0000
C       X (K=1), DX/DS(K=2), Y(K=3), DY/DS(K=4) OF N-TH PHOTON          0000
C       EMITTED BY L-TH BEAM.                                           0000
C       (X,Y) IS THE INTERCEPT OF PHOTON TRAJECTORY ON S=0 PLANE. METER.0000
C       DX/DS, DY/DS  IN RADIAN.                                        0000
C ((EPH(N,L),N=1,NPH(L)),L=1,2)                                         0000
C       PHOTON ENERGY IN UNITS OF E0(L).                                0000
C ((RPPH(N,L),N=1,NPH(L)),L=1,2)                                        0000
C       RADIAL ANGLE  SQRT((DX/DS)**2+(DY/DS)**2) IN RADIAN.            0000
C----- FOLLOWING TWO ITEMS ARE DIFINED IF LSHIST>=1.                    0000
C (SBIN(I),I=1,NSBIN)                                                   0000
C       SPECTRUM OF S=(CENTER-OF-MASS ENERGY)**2. BIN WIDTH IS          0000
C       WS=(SBMAX-SBMIN)/NSBIN AND THE LOWER EDGE OF THE I-TH BIN       0000
C       IS S=SBMIN+WS*(I-1). (S IN UNITS OF S0=4*E0(1)*E0(2).)          0000
C       SBIN(I) IS THE CONTRIBUTION OF THE I-TH BIN TO THE LUMINOSITY   0000
C       IN UNITS OF 1/CM**2/SEC/BIN.                                    0000
C ((SBIN2(I,J),I=1,NSBIN),J=1,NSBIN)                                    0000
C       2-DIM ENERGY SPECTRUM OF LUMNINOSITY.                           0000
C       I-TH BIN: EBMIN+WE*(I-1) < E1/E0(1) < EBMIN+WE*I                0000
C       J-TH BIN: EBMIN+WE*(I-1) < E2/E0(2) < EBMIN+WE*I                0000
C             WE=(EBMAX-EBMIB)/NSBIN                                    0000
C       SBIN2(I,J) IS THE CONTRIBUTION OF (I,J)-TH BIN TO THE           0000
C       LUMINOSITY IN UNITS OF 1/CM**2/SEC/BIN.                         0000
C----- FOLLOWING SIX ITEMS ARE DIFINED IF LCMPTN>=1.                    0000
C (CPLUM(L),L=1,2)   COMPTON SCATTERING LUMINOSITY BETWEEN L-TH BEAM    0000
C       AND THE PHOTONS FROM THE OTHER BEAM.                            0000
C ((CPBN(I,L),I=1,NSBIN),L=1,2)                                         0000
C       CENTER-OF-MASS ENERGY SPECTRUM OF COMPTON SCATTERING            0000
C       BETWEEN L-TH BEAM AND THE PHOTONS FROM THE OTHER BEAM.          0000
C       UNITS: 1/CM**2/SEC/BIN                                          0000
C       I SPECIFIES S= (CM ENERGY)**2 :                                 0000
C          CSBMIN+WCS*(I-1) < S/S0 < CSBMIN+WCS*I                       0000
C          WCS=(CSBMAX-CSBMIN)/NSBIN                                    0000
C (((CPB2(I,J,L),I=1,NSBIN),J=1,NSBIN),L=1,2)                           0000
C       2-DIM SPECTRUM OF COMPTON SCATTERING. 1/CM**2/SEC/BIN.          0000
C         I:ELECTRON ENERGY BIN,  SEE SBIN FOR DEFINITION.              0000
C         J:PHOTON ENERGY BIN.                                          0000
C           CBMIN+WC*(I-1) < EPH/E0 < CBMIN+WC*I                        0000
C               WC=(CBMAX-CBMIN)/NSBIN                                  0000
C GGLUM  LUMINOSITY OF GAMMA-GAMMA SCATTERING IN 1/CM**2/SEC            0000
C (GGBN(I),I=1,NSBIN)                                                   0000
C       CENTER-OF-MASS ENERGY SPECTRUM OF GAMMA-GAMMA SCATTERING.       0000
C       UNITS: 1/CM**2/SEC/BIN                                          0000
C       I SPECIFIES S= (CM ENERGY)**2 :                                 0000
C          GSBMIN+WGS*(I-1) < S/S0 < GSBMIN+WGS*I                       0000
C          WGS=(GSBMAX-GSBMIN)/NSBIN                                    0000
C ((GGB2(I,J),I=1,NSBIN),J=1,NSBIN)                                     0000
C       2-DIM SPECTRUM OF GAMMA-GAMMA SCATTERING. 1/CM**2/SEC/BIN.      0000
C         I:PHOTON ENERGY BIN FROM BEAM#1                               0000
C         J:PHOTON ENERGY BIN FROM BEAM#2                               0000
C            SEE CPB2 FOR ENERGY OF PHOTON BIN.                         0000
C                                                                       0000
C----- FOLLOWING SIX ITEMS ARE DIFINED IF NLEP>0.                       0000
C NLEP     NUMBER OF GENERATED LOW ENERGY PARTICLES.                    0000
C          (FORWARD OF BEAM#1 ONLY)                                     0000
C ELEMIN,ELEMAX   ENERGY WINDOW IN UNITS OF E0(1).                      0000
C (EELE(N),N=1,NLEP)   ENERGY OF N-TH PARTICLE IN UNITS OF E0(1).       0000
C ((XYLE(N,1,IXY),N=1,NLEP),IXY=1,2)                                    0000
C       X(IXY=1) AND Y(IXY=2) OF THE INTERCEPT ON S=0 PLANE OF N-TH     0000
C       PARTICLE.  (METER)                                              0000
C ((XYLE(N,2,IXY),N=1,NLEP),IXY=1,2)                                    0000
C       FINAL DX/DS(IXY=1) AND DY/DS(IXY=2). (RADIAN)                   0000
C (LEOR(N),N=1,NLEP)  ORIGIN AND CHARGE OF N-TH PARTICLE.               0000
C       >0: SAME CHARGE AS BEAM#1,  <0: OPPOSITE SIGNATURE.             0000
C       ABS(LEOR(N))=1:  BREMS. I.E., E(+)+E(-)---> GAMMA+E(+)+E(-)     0000
C       =2: BETHE-HEITLER.                                              0000
C                   I.E., E + GAMMA(BEAMSTRAHLUNG) --> E+E(+)+E(-)      0000
C       =3: LANDAU-LIFSHITZ. I.E., E(+)+E(-)---> E(+)E(-)E(+)E(-)       0000
C (THINLE(I),I=1,3)  THINNING FACTOR FOR EACH OF THE ABOVE THREE        0000
C       PROCESSES. (THINBR,THINBH,THINLL)                               0000
C                                                                       0000
      REAL*4 E0(2),SIG(3,2),DSRP(2,2)                                   0000
      REAL*4 XY(NP,2,2),XYP(NP,2,2),ZZ(NP,2),RP(NP,2)                   0000
      REAL*8 ENG(NP,2)                                                  0000
      REAL*4 XYPH(MAXPH,4,2),EPH(MAXPH,2),RPPH(MAXPH,2)                 0000
      INTEGER NPH(2),IPHEL(MAXPH,2)                                     0000
      REAL*4 SBIN2(NSBIN,NSBIN),SBIN(NSBIN)                             0000
      REAL*4 CPLUM(2),CPB2(NSBIN,NSBIN,2),CPBN(NSBIN,2)                 0000
      REAL*4 GGB2(NSBIN,NSBIN),GGBN(NSBIN)                              0000
      REAL*4 EELE(NLEP),XYLE(MAXLEP,2,2),THINLE(3)                      0000
      INTEGER LEOR(NLEP)
C                                                                       0000
      REAL*8 AV(7)                                                      0000
      E(I)=EBMIN+(EBMAX-EBMIN)/NSBIN*(I-1)                              0000
      S(I)=SBMIN+(SBMAX-SBMIN)/NSBIN*(I-1)                              0000
      CS(I)=CSBMIN+(CSBMAX-CSBMIN)/NSBIN*(I-1)                          0000
      GS(I)=GSBMIN+(GSBMAX-GSBMIN)/NSBIN*(I-1)                          0000
      CE(I)=CBMIN+(CBMAX-CBMIN)/NSBIN*(I-1)                             0000
C                                                                       0000
      WRITE(6,100) E0(1),E0(2),((SIG(I,L),L=1,2),I=1,3),                0000
     %    ((DSRP(L,IXY),L=1,2),IXY=1,2),                                0000
     %    CGSLM0,CGSLUM,(CPLUM(L),L=1,2),GGLUM                          0000
  100 FORMAT('1  E0=',0P2F8.3,/,                                        0000
     %   '  SIGX=',1P2E10.3,' SIGY=',1P2E10.3,' SIGZ=',1P2E10.3,/,      0000
     %   '  DSRX=',1P2E10.3,' DSRY=',1P2E10.3,/,                        0000
     %   '   LUMINOSITY=',1P2E12.5,'   CPLUM=',1P2E12.5,                0000
     %   '  GGLUM=',1PE12.5)                                            0000
      DO 150 L=1,2                                                      0000
      DO 110 I=1,7                                                      0000
  110 AV(I)=0                                                           0000
      DO 120 N=1,NP                                                     0000
      AV(1)=AV(1)+XY(N,1,L)                                             0000
      AV(2)=AV(2)+XYP(N,1,L)                                            0000
      AV(3)=AV(3)+XY(N,2,L)                                             0000
      AV(4)=AV(4)+XYP(N,2,L)                                            0000
      AV(5)=AV(5)+ZZ(N,L)                                               0000
      AV(6)=AV(6)+ENG(N,L)                                              0000
      AV(7)=AV(7)+RP(N,L)                                               0000
  120 CONTINUE                                                          0000
      DO 130 I=1,7                                                      0000
  130 AV(I)=AV(I)/NP                                                    0000
      WRITE(6,140) L,(AV(I),I=1,7)                                      0000
  140 FORMAT(' AVEL(L=',I1,')=',1P7D15.6)                               0000
  150 CONTINUE                                                          0000
C                                                                       0000
      DO 250 L=1,2                                                      0000
      DO 210 I=1,7                                                      0000
  210 AV(I)=0                                                           0000
      DO 220 N=1,NPH(L)                                                 0000
      AV(1)=AV(1)+XYPH(N,1,L)                                           0000
      AV(2)=AV(2)+XYPH(N,2,L)                                           0000
      AV(3)=AV(3)+XYPH(N,3,L)                                           0000
      AV(4)=AV(4)+XYPH(N,4,L)                                           0000
      AV(5)=AV(5)+ZZ(IPHEL(N,L),L)                                      0000
      AV(6)=AV(6)+EPH(N,L)                                              0000
      AV(7)=AV(7)+RPPH(N,L)                                             0000
  220 CONTINUE                                                          0000
      DO 230 I=1,7                                                      0000
  230 AV(I)=AV(I)/NPH(L)                                                0000
      WRITE(6,240) L,(AV(I),I=1,7)                                      0000
  240 FORMAT(' AVPH(L=',I1,')=',1P7D15.6)                               0000
  250 CONTINUE                                                          0000
C                                                                       0000
      IF(LSHIST.LE.0) GOTO 500                                          0000
      WRITE(6,360) (I,E(I),S(I),I=1,NSBIN)                              0000
  360 FORMAT(/,' ----- I,E(I),S(I) -----',/,                            0000
     % 8(I4,2F6.3))                                                     0000
      WRITE(6,400) (I,SBIN(I),I=1,NSBIN)                                0000
  400 FORMAT(' -----SBIN-----',/,(1X,8(I3,1PE9.2)))                     0000
      WRITE(6,410) ((I,J,SBIN2(I,J),I=1,NSBIN),J=1,NSBIN)               0000
  410 FORMAT(' -----SBIN2----',/,(1X,8(1X,2I2,1PE9.2)))                 0000
      IF(LCMPTN.LE.0) GOTO 500                                          0000
      WRITE(6,420) (I,CE(I),CS(I),GS(I),I=1,NSBIN)                      0000
  420 FORMAT(/,' ----- I,CE(I),CS(I),GS(I) -----',/,                    0000
     % 5(I4,3F6.3))                                                     0000
      DO 460 L=1,2                                                      0000
      WRITE(6,430) L                                                    0000
  430 FORMAT(' -----COMPTON L=',I1,'-----')                             0000
      WRITE(6,440) (I,CPBN(I,L),I=1,NSBIN)                              0000
  440 FORMAT(' -----CPBN-----',/,(1X,8(I3,1PE9.2)))                     0000
      WRITE(6,450) ((I,J,CPB2(I,J,L),I=1,NSBIN),J=1,NSBIN)              0000
  450 FORMAT(' -----CPB2----',/,(1X,8(1X,2I2,1PE9.2)))                  0000
  460 CONTINUE                                                          0000
      WRITE(6,470) (I,GGBN(I),I=1,NSBIN)                                0000
  470 FORMAT(' -----GGBN-----',/,(1X,8(I3,1PE9.2)))                     0000
      WRITE(6,480) ((I,J,GGB2(I,J),I=1,NSBIN),J=1,NSBIN)                0000
  480 FORMAT(' -----GGB2----',/,(1X,8(1X,2I2,1PE9.2)))                  0000
  500 RETURN                                                            0000
      END                                                               0000
